<?php
require_once 'PEAR.php';
require_once 'HTTP/Client.php';

require_once 'ObjMixi/ObjBbs.php';
require_once 'ObjMixi/ObjBbsHeader.php';
require_once 'ObjMixi/ObjComment.php';
require_once 'ObjMixi/ObjCommunity.php';
require_once 'ObjMixi/ObjDiary.php';
require_once 'ObjMixi/ObjDiaryHeader.php';
require_once 'ObjMixi/ObjLog.php';
require_once 'ObjMixi/ObjMessage.php';
require_once 'ObjMixi/ObjMessageHeader.php';
require_once 'ObjMixi/ObjUser.php';

/**
 * MixiClientΥ١饹
 * @package MixiClient
 * @abstract
 */
abstract class _BaseMixiClient {
	
	/**
	 * mixiurl
	 * @var String  
	 */
	public $URL_MIXI		= "http://mixi.jp/";
	
	/**
	 * ƥƥĤURL
	 * @var array String
	 */
	public $URL_CON = array (
		"LOGIN"				=> "login.pl",						//
		"HOME"				=> "home.pl",						//ȥåץڡ
		"NIKKI_FRIEND"		=> "new_friend_diary.pl",			//ޥߥǿ(1ʬ)
		"NEW_COMMENT"		=> "new_comment.pl",				//ȵ(1ʬ)		
		"NEW_BBS"			=> "new_bbs.pl",					//ߥ˥ƥǿ񤭹(1ʬ)		
		"LIST_DIARY"		=> "list_diary.pl",					//ǿ(ʬ)
		"VIEW_DIARY"		=> "view_diary.pl",					//1
		"VIEW_BBS"			=> "view_bbs.pl",					//ߥ1
		"EVENT_VIEW"		=> "view_event.pl",					//٥1
		"ADD_DIARY"			=> "add_diary.pl",					//
		"ADD_COMMENT"		=> "add_comment.pl",				//˥
		"ADD_COMMENT_BBS"	=> "add_bbs_comment.pl",			//ߥ˥
		"SHOW_LOG"			=> "show_log.pl",					//Ƕ­
		"LIST_FRIEND"		=> "list_friend.pl",				//ޥߥ
		"LIST_COMM"			=> "list_community.pl",				//ߥ˥ƥ
		"LIST_MESSAGE"		=> "list_message.pl",				//å
		"LIST_BOOKMARK"		=> "list_bookmark.pl",				//
		//"MESSAGE_INBOX"		=> "list_message.pl?box=inbox",	//Ȣꥹ
		//"MESSAGE_OUTBOX"	=> "list_message.pl?box=outbox",	//Ȣꥹ
		//"MESSAGE_SAVEBOX"	=> "list_message.pl?box=savebox",	//¸Ȣ
		//"MESSAGE_THRASH"	=> "list_message.pl?box=thrash",	//Ȣ
		"VIEW_MESSAGE"		=> "view_message.pl",				//å
		//"VIEW_OUTBOX"		=> "view_message.pl",				//Ȣ		
		"MESSAGE_SEND"		=> "send_message.pl",				//
		"MESSAGE_REPLY"		=> "reply_message.pl"				//ֿ
	);
	
	/**
	 * http client
	 * @var HTTP/Client
	 */
	private $client;
	
	/**
	 * ƥĤֵ
	 * 
	 * @access	protected
	 * @param	String		$contentsName	åȥƥ
	 * @param	String		$param			URLΥѥ᡼
	 * @return	String		ƥʸ
	 * @throws	Exception
	 */
	protected function getContents($contentsName,$param){
		$result = null;
		try{
			$result = $this->get($this->URL_MIXI.$this->URL_CON[$contentsName].$param);
		} catch (Exception $e) {
			throw new Exception(__METHOD__." ".__LINE__." match=empty");
		}
		return $result;
	}
	
	/**
	 * ƥĤpreg_match򤫤
	 * 
	 * @access	protected
	 * @param String			$contentsName		åȥƥ̾
	 * @param String			$param				URLΥѥ᡼
	 * @param String			$pattern			preg_matchѰ
	 * @return array|string	preg_match
	 * @throws	Exception
	 */
	protected function getContentsMatches($contentsName,$param,$pattern){
		try{
			$contents = $this->getContents($contentsName,$param);
			$matches = $this->getMatches($pattern,$contents);
		} catch (Exception $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
		return $matches;
	}
	
	/**
	 * preg_match򤫤
	 * 
	 * @access	protected
	 * @param	String			$str		ƥʸ
	 * @param	String			$pattern	preg_matchѰ
	 * @return array|string	preg_match
	 * @throws	Exception
	 */
	protected function getMatches($pattern,$str){
		$matches = null;
		try{
			preg_match_all($pattern,$str,$matches);
			if(isset($matches) == FALSE || is_array($matches) == FALSE || isset($matches[1]) == FALSE){
				throw new Exception(__METHOD__." ".__LINE__);
			}
		} catch (Exception $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
		return $matches;
	}
	
	/**
	 * POST
	 * 
	 * @access	protected
	 * @param	String	$contentsName		åȥƥ̾
	 * @param	String	$param				URLղäѥ᡼
	 * @param	String	$data				POSTϢ
	 */
	protected function postContents($contentsName,$param,$data){
		$result = null;
		try{
			$result = $this->post($this->URL_MIXI.$this->URL_CON[$contentsName].$param,$data);
		} catch (Exception $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__." match=empty");
		}
		return $result;
	}
	
	/**
	 * POST(ֳǧ̡פȡֽ񤭹ߡפη2Ԥ)
	 * 
	 * @access	protected
	 * @param	String	$contentsName		åȥƥ̾
	 * @param	String	$param				URLղäѥ᡼
	 * @param	String	$data				POSTϢ
	 */
	protected function postContentsConfirm($contentsName,$param,$data)
	{
		try{
			//ǧ̤POST
			$contents = $this->postContents($contentsName,$param,$data);
			//post_keyμ
			$post_key = $this->getPostKey($contents);
			
			$data["submit"] = "confirm";
			$data["post_key"] = $post_key;
			
			//񤭹POST
			$contents = $this->postContents($contentsName,$param,$data);
			
		} catch (Exception $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
	}
	
	/**
	 * HTML
	 * 
	 * @access	protected
	 * @param	String	$str	ʸ
	 * @return String			ʸ
	 */
	protected function removeTags($str){
		//
		$str = preg_replace("/<img src=\"(http.*?)\"(.*?)>/i","img".'$1'."",$str);
		//ʸ
		$str = preg_replace("/<a href=\"(http.*?)\">(.*?)<\/a>/i",'$2'."(".'$1'.")",$str);
		
		//HTML ƥƥŬڤʸѴ
		$str = html_entity_decode($str);
		//ʸ󤫤HTMLPHP
		$str = strip_tags($str);
		
		return $str;
	}
	
	/**
	 * ʸ򥿥ॹפˤֵ
	 * 
	 * MEMO1.12006ǯ1216 17:0622006/12/16 17:06
	 * 
	 * @access	protected
	 * @param	String	ʸ
	 * @return integer ॹ / Ѵ=FALSE
	 */
	protected function parseDate($date){
		$result = FALSE;
		$pattern = "/([0-9]{4})(.*?)([0-9]{2})(.*?)([0-9]{2})(.*?)([0-9]{2})(.*?)([0-9]{2})/";
		try{
			$matches = $this->getMatches($pattern,$date);
		} catch (Exception $e) {
			return FALSE;
		}
		
		$result = mktime(
			trim($matches[7][0]),	//
			trim($matches[9][0]),	//ʬ
			0,						//
			trim($matches[3][0]),	//
			trim($matches[5][0]),	//
			trim($matches[1][0])	//ǯ
		);
		
		return $result;
	}
	
	/**
	 * URLȴФϢǼ
	 * <code>
	 * view_diary.pl?id=293570364&owner_id=730962
	 * 
	 * result[id] => 293570364
	 * result[owner_id] => 730962
	 * </code>
	 * @access	protected
	 * @param	string			$url	URLʸ
	 * @return	array|string			
	 */
	protected function parseUrl($url){
		$matches = preg_split("/(\?|&|\"|<|>|\s)/",$url);
		$result = array();
		foreach($matches as $match){
			$arr = split("=",$match);
			if($arr !== FALSE && isset($arr[0]) && isset($arr[1])){
				$arr[0] = trim($arr[0]);
				$arr[1] = trim($arr[1]);
				if($arr[0] != "" && $arr[1] != ""){
					$result[$arr[0]] = $arr[1];
				}
			}
		}
		return $result;
	}
	
	/**
	 * inputȴФϢǼ
	 * <code>
	 * <input type="hidden" name="post_key" value="aaaa">
	 * 
	 * result[type] => hidden
	 * result[name] => post_key
	 * result[value] => aaaa
	 * </code>
	 * @access	protected
	 * @param	string			$url	inputʸ
	 * @return	array|string			
	 */
	protected function parseInputTag($str)
	{
		preg_match_all("/(\S*?)(=)(.*?)(\s|>)/",$str,$matches);
		$input = array();
		if(is_array($matches) && is_array($matches[0])){
			for($count=0;$count<count($matches[0]);$count++){
				$input[$matches[1][$count]] = str_replace("\"","",$matches[3][$count]);
			}
		}
		return $input;
	}
	
	/**
	 * HOME鼫ʬid
	 * 
	 * @access	protected
	 * @return String	id
	 * @throws	Exception
	 */
	protected function getOwnId(){
		try{
			$body = $this->getContents("HOME","");
			$pattern = "/(<a href=\"show_profile\.pl\?id=)(.*?)(\")/is";
			preg_match($pattern,$body,$matches);
			if(isset($matches) == FALSE || is_array($matches) == FALSE || isset($matches[2]) == FALSE){
				throw new Exception(__METHOD__." ".__LINE__);
			}
		} catch (Exception $e) {
			return FALSE;
		}
		return trim($matches[2]);
	}
	
	/**
	 * post_key
	 * 
	 * @access	protected
	 * @param	String			$body		ƥʸ
	 * @return String	post_key
	 * @throws	Exception
	 */
	protected function getPostKey($body){
		//post_keyιԤ
		$pattern = "/<input.*?post_key.*?>/";
		preg_match($pattern,$body,$matches);
		if(isset($matches) == FALSE || is_array($matches) == FALSE){
			throw new Exception(__METHOD__." ".__LINE__." no post_key line.");
		}
		
		$arr = $this->parseInputTag($matches[0]);
		if(isset($arr["value"]) === FALSE){
			throw new Exception(__METHOD__." ".__LINE__." no post_key.");
		}
		
		$post_key = trim($arr["value"]);
		
		return $post_key;
	}
	
	/**
	 * 
	 * 
	 * @access	public
	 * @param String	$email		ѥ᡼륢ɥ쥹
	 * @param String	$password	ѥѥ
	 * @param String	$next_url	ܤڡ
	 * @return String	ܤڡ
	 * @throws	Exception
	 */
	public function login($email,$password,$next_url){
		$result = NULL;
		$loginPrm = array(
			"email"		=> $email,
			"password"	=> $password,
			"next_url"	=> $next_url
		);
		try {
			$this->client =& new HTTP_Client();
			$this->client->post($this->URL_MIXI.$this->URL_CON["LOGIN"],$loginPrm);
			$result = $this->client->currentResponse();
			
			if(isset($result['code']) === FALSE){				//̥֥
				throw new Exception(__METHOD__." ".__LINE__." http_response=empty");
			} else if($result['code'] != "200"){				//쥹ݥ󥹥
				throw new Exception(__METHOD__." ".__LINE__." http_response!=200(".$result['code'].")");
			} else if(isset($result['body']) === FALSE){		//̥֥
				throw new Exception(__METHOD__." ".__LINE__." match=empty");
			}
			
		} catch (PEAR_Error $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
		
		return $result['body'];
	}
	
	/**
	 * URL饳ƥĤμ
	 * 
	 * @access	private
	 * @param	String	$target_url		URL
	 * @return	String	body
	 * @throws	Exception
	 */	
	private function get($target_url){
		//print $target_url;
		$HTTP_response = "";			//HTTP쥹ݥ󥹥
		$result = FALSE;
		try{
			$this->client->get($target_url);
			$result = $this->client->currentResponse();
			
			if(isset($result['code']) === FALSE){				//̥֥
				throw new Exception(__METHOD__." ".__LINE__." http_response=empty");
			} else if($result['code'] != "200"){				//쥹ݥ󥹥
				throw new Exception(__METHOD__." ".__LINE__." http_response!=200(".$result['code'].")");
			} else if(isset($result['body']) === FALSE){		//̥֥
				throw new Exception(__METHOD__." ".__LINE__." match=empty");
			}
		} catch (PEAR_Error $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		} catch (Exception $e){
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
		
		return $result['body'];
	}
	
	/**
	 * URL饳ƥĤؤPOST
	 * 
	 * @access	private
	 * @param	String	$url	POSTURL
	 * @return	String	$data	ղåǡ
	 * @throws	Exception
	 */	
	private function post($url,$data){
		$result = NULL;			//HTTP쥹ݥ󥹥
		try{
			//̤URL󥳡ɤ򥪥ץ
			$this->client->post($url,$data,FALSE);
			$result = $this->client->currentResponse();
			
			if(isset($result['code']) === FALSE){				//̥֥
				throw new Exception(__METHOD__." ".__LINE__." http_response=empty");
			} else if($result['code'] != "200"){				//쥹ݥ󥹥
				throw new Exception(__METHOD__." ".__LINE__." http_response!=200(".$result['code'].")");
			} else if(isset($result['body']) === FALSE){		//̥֥
				throw new Exception(__METHOD__." ".__LINE__." body=empty");
			}
		} catch (PEAR_Error $e) {
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		} catch (Exception $e){
			throw new Exception($e->getMessage()."\n".__METHOD__." ".__LINE__);
		}
		
		return $result['body'];
	}
}

?>

